/*****
*
*  Environ.prg
*
*  ਬ 짮⥫᪨ 楤  㭪権  ᯥ祭 㯠
*   䠩  Clipper-ணࠬ  ࠢ SET-⠭.
*
*  Copyright, Nantucket Corporation, 1990
*  Apr 19, 1990
*
*  ஢  ﬨ /n/w/a/m
*
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/


#include "Set.ch"


/***
*  FilePath( <cFile> ) --> cFilePath
*  뤥  㯠    䠩
*
*/
FUNCTION FilePath( cFile )
   LOCAL nPos, cFilePath
   IF (nPos := RAT("\", cFile)) != 0
      cFilePath := SUBSTR(cFile, 1, nPos)
   ELSE
      cFilePath := ""
   ENDIF
   RETURN cFilePath



/***
*  FileBase( <cFile> ) --> cFileBase
*  뤥 쬨 ᨬ    䠩
*
*/
FUNCTION FileBase( cFile )
   LOCAL nPos, cFileBase

   DO CASE
   CASE (nPos := RAT("\", cFile)) != 0
      // १  
      cFileBase := SUBSTR(cFile, nPos + 1)
   CASE (nPos := AT(":", cFile)) != 0
      // १ ᨬ ன⢠
      cFileBase := SUBSTR(cFile, nPos + 1)
   OTHERWISE
      cFileBase := cFile
   ENDCASE

   // १ ७, ᫨  
   IF (nPos := AT(".", cFileBase)) != 0
      cFileBase := SUBSTR(cFileBase, 1, nPos - 1)
   ENDIF

   RETURN cFileBase



/***
*  FileExt( <cFile> ) --> cFileExt
*  뤥  ᨬ ७   䠩
*
*/
FUNCTION FileExt( cFile )
   LOCAL nPos, cFileExt

   IF (nPos := RAT(".", cFile)) != 0
      cFileExt := SUBSTR(cFile, nPos + 1)
   ELSE
      cFileExt := ""
   ENDIF

   RETURN cFileExt



/***
*  FileDrive( <cFile> ) --> cFileDrive
*  뤥 ᨬ 祭 ன⢠   䠩
*
*/
FUNCTION FileDrive( cFile )
   LOCAL nPos, cFileDrive := ""

   IF (nPos := AT(":", cFile)) != 0
      cFileDrive := SUBSTR(cFile, 1, nPos - 1)
   ENDIF

   RETURN cFileDrive


/***
*  FullPath( <cFile>, <lDosPath> ) --> cFullPath
*  頥   䠩 cFile; 㫨 FoxPro 㭪 FULLPATH()
*/
FUNCTION FullPath( cFile, lDosPath )
   LOCAL cDefault, cPath

   cDefault := SET(_SET_DEFAULT)
   cDefault += IF( RIGHT(RTRIM(cDefault), 1) != "\", "\", "") + cFile

   IF FILE( cDefault )
      cPath := cDefault
   ELSE
      IF lDosPath = NIL .OR. !lDosPath
         cPath := GetPath( cFile, SET(_SET_PATH) )
      ELSE
         cPath := GetPath( cFile, GETENV( "PATH" ) )
      ENDIF
   ENDIF
   RETURN IF( cPath = NIL, cDefault, cPath )



/***
*  GetPath( <cFile>, <cPathSpec> ) --> cPath
*  頥  㯠  䠩  NIL, ᫨ 䠩  
*
*  ਬ砭: 뢠 㭪 ListAsArray(), ।  String.prg
*/
FUNCTION GetPath( cFile, cPathSpec )
   LOCAL aPathList, bFilePath, cPath, nPos

   bFilePath := { |cPath| FILE( cPath + ;
	  IF( RIGHT(RTRIM(cPath), 1) != "\", "\", "") + cFile ) }

   aPathList := ListAsArray( STRTRAN(cPathSpec, ",", ";"), ";" )

   IF (nPos := ASCAN( aPathList, bFilePath )) != 0
      RETURN aPathList[ nPos ]
   ENDIF
RETURN NIL


/***
*  SetAll( [<aNewSets>] ) --> aCurrentSets
*  ᯮ ᨢ ⠭,  ⠭ SET-ࠬ஢ 
*  頥  ࠭ ⠭ 祭  ᨢ. ᫨ ᨢ
*   ।,   頥 ⥪騥 祭
*
*/
FUNCTION SetAll( aNewSets )
   LOCAL aCurrentSets[_SET_COUNT], n
   IF ( aNewSets != NIL )              // ⠭    
      FOR n := 1 TO _SET_COUNT
         aCurrentSets[n] := SET(n, aNewSets[n])
      NEXT
   ELSE                                // ⮫쪮  ⥪騥
      FOR n := 1 TO _SET_COUNT
         aCurrentSets[n] := SET(n)
      NEXT
   ENDIF
   RETURN (aCurrentSets)