/***
*   examplec.c
*   ਬ C-㭪権 ᯮ 䥩 Clipper-⥬ ७.
*/
/***********
* 䨪 ந  ""  ५ -  1991 .
*     祭 Nantucket Corp.
* ⥫.: (095) 289-43-00, (095) 289-44-77, (095) 289-44-83
* 䠪: (095) 289-34-69
************/

#include "extend.h"


/* ᯮ ,   ਫ */
#define ISALPHA(c)  ( (c) >= 'a' && (c) <= 'z' || (c) >= 'A' && (c) <= 'Z' )
#define TOUPPER(c)  ( (c) >= 'a' && (c) <= 'z' ? (c) - 'a' + 'A' : (c) )

#define SOUNDEX_LENGTH	4


/***
*   step2()
*    SOUNDEX-१  㪢.
*   Soundex -  ஢   祢 ᫮.
*/

static char step2(char c)

{
	switch (c)
	{
		case 'B':
		case 'F':
		case 'P':
		case 'V':
			return ('1');

		case 'C':
		case 'G':
		case 'J':
		case 'K':
		case 'Q':
		case 'S':
		case 'X':
		case 'Z':
			return ('2');

		case 'D':
		case 'T':
			return ('3');

		case 'L':
			return ('4');


		case 'M':
		case 'N':
			return ('5');

		case 'R':
			return ('6');

		case 'A':
		case 'E':
		case 'H':
		case 'I':
		case 'O':
		case 'U':
		case 'W':
		case 'Y':
			return (NIL);
	}

    /* ⢨⥫ ࠬ -- १  ᥬ 訡 */
	return ('9');
}


/***
*   SoundexC()
*   ८ࠧ ப  SOUNDEX- (C-뢠).
*
*   "Soundex" - Odell/Russell (1918) ⠭ ,
*   ନ騩   ଥ "㪢, , , ",
*    ᫥騬 ࠢ
*
*   1)  ࢠ 㪢  .
*
*   2)    ᫥饩 㪢 ନ १ 
*       ᫥饩 ⠡:
*
*       㪢                           १
*
*       B, F, P, V                       1
*       C, G, J, K, Q, S, X, Z           2
*       D, T                             3
*       L                                4
*       M, N                             5
*       R                                6
*       A, E, H, I, O, U, W, Y          (祣)
*
*
*   3)  ᫨     㪢 ନ 
*       १  蠣 2,  , ஬ ࢮ, .
*
*   4)   蠣 2  3   ,   
*         ᨬ   㪢 室 ᫮.
*
*   5)  ᫨ 祭   ,   㫨 ࠢ.
*
*
*   ਬ砭:
*
*   䠢 ( ⨭᪨) ᨬ  ;
*   ᨬ, ⤥  䠢 ᨬ, 
*   ᬥ묨. ᫨ 室 ᫮  ᮤন 䠢 ᨬ,
*    頥 "0000".
*
*   訥   㪢  ࠧ.
*
*   㪢, ନ騥  (祣)  蠣 2,   蠣 3.
*    㪢, ନ騥    ࠧ ᨬ,
*   த騬 (nothing),   ᬥ묨,  ᮮ⢥
*   ਣ쭮 .
*
*    C-뢠 㭪 頥 㪠⥫  ᪨ ,
*   ᮤন ண ९뢠  ᫥ 맮.
*/

static char *SoundexC(char *source, short len)

{
	static char code[SOUNDEX_LENGTH+1] = "";

    short i;
    short j;
	char c;
	char result;
	char prev;


    /* ନ஢ Soundex  */
	for ( i = 0, j = 0, prev = NIL;  i < len && j < SOUNDEX_LENGTH;  i++ )
    {
		c = TOUPPER(source[i]);

		if ( ISALPHA(c) )
		{
			result = step2(c);

			if (j == 0)
			{
                /* ࠭ ࢮ ᨬ */
				code[j++] = c;
			}
			else if ( result != NIL && result != prev )
			{
                /*  soundex  */
				code[j++] = result;
			}

			prev = result;
		}
    }


    /*  ﬨ ࠢ */
	while (j < SOUNDEX_LENGTH)
		code[j++] = '0';


	return (code);
}


/***
*   SOUNDEX()
*   ନ஢ "Soundex"   ப (Clipper-뢠)
*
*   cSoundexCode := SOUNDEX(cString)
*/

CLIPPER SOUNDEX(void)

{
    char *code;


    if ( PCOUNT >= 1 && ISCHAR(1) )
	{
		code = SoundexC( _parc(1), _parclen(1) );
	}
	else
	{
		code = "0000";
	}


	_retclen(code, SOUNDEX_LENGTH);
}




/***
*	bcopy()
*   ९ 'count' ⮢  
*/

static void bcopy(byte *to, byte *from, quant count)

{
	while ( count-- )
		*to++ = *from++;
}




/***
*   StuffC()
*    ᨬ  ப (C-뢠)
*
*	StuffC( str, len, pos, del, iStr, iLen )
*
*    'del' ᨬ  'str', 稭  樨 'pos',
*   ⠢ iLen ᨬ ப 'iStr'   .  'len'
*   ⭮  'str',  'iLen' ⭮  'iStr'.  
*         ࠢ .
*/

static void StuffC( byte *str, quant len, quant pos, quant del,
					byte *iStr, quant iLen )

{
	long oLen;
	byte *result;


    /* ८ࠧ */
	if ( pos > 0 )
		pos--;

    /* ࠭祭 */
	if ( pos > len )
		pos = len;

	if ( del > len - pos )
		del = len - pos;

    /* long ᯮ  ।饭 ९ */
	oLen = (long)len + (long)iLen - (long)del;
	if ( oLen > 0L && oLen < 65500L )
	{
        /* । ࠭⢠   */
        result = _xgrab((quant)oLen + 1);

        /* ஥ १饩 ப */
		bcopy(result, str, pos);
		bcopy(&result[pos], iStr, iLen);
		bcopy(&result[pos + iLen], &str[pos + del], len - (pos + del));
		result[oLen] = NIL;

        /*  ப  Clipper */
		_retclen(result, (quant)oLen);
		_xfree(result);
	}
	else
		_retc("");
}




/***
*	STUFF()
*   頥 'del' ᨬ  ப 'str', 稭  樨
*       'pos'  ப 'iStr'.
*
*	result = STUFF(str, pos, del, iStr)
*
*       result      -   ᨬ쭠 ப.
*       str         -   ᨬ쭠 ப.
*       pos         -   ᫮.
*       del         -   ᫮.
*       iStr        -   ᨬ쭠 ப.
*
**/

CLIPPER STUFF(void)

{
	if (PCOUNT == 4 && ISCHAR(1) &&
		ISNUM(2) && ISNUM(3) && ISCHAR(4) )
	{
		StuffC(_parc(1), _parclen(1), _parni(2),
			   _parni(3), _parc(4), _parclen(4));
	}
	else
		_retc("");
}